
#ifndef IMAGED11_CMATH_H
#define IMAGED11_CMATH_H

#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define RAD M_PI / 180.0
#define DEG 180.0 / M_PI

#define vec3sub(a, b, c)                                                       \
    (c)[0] = (a)[0] - (b)[0];                                                  \
    (c)[1] = (a)[1] - (b)[1];                                                  \
    (c)[2] = (a)[2] - (b)[2];

#define crossProduct(a, b, c)                                                  \
    (c)[0] = (a)[1] * (b)[2] - (b)[1] * (a)[2];                                \
    (c)[1] = (a)[2] * (b)[0] - (b)[2] * (a)[0];                                \
    (c)[2] = (a)[0] * (b)[1] - (b)[0] * (a)[1];

#define matvec(a, b, c)                                                        \
    (c)[0] = (a)[0] * (b)[0] + (a)[1] * (b)[1] + (a)[2] * (b)[2];              \
    (c)[1] = (a)[3] * (b)[0] + (a)[4] * (b)[1] + (a)[5] * (b)[2];              \
    (c)[2] = (a)[6] * (b)[0] + (a)[7] * (b)[1] + (a)[8] * (b)[2];

#define matTvec(a, b, c)                                                       \
    (c)[0] = (a)[0] * (b)[0] + (a)[3] * (b)[1] + (a)[6] * (b)[2];              \
    (c)[1] = (a)[1] * (b)[0] + (a)[4] * (b)[1] + (a)[7] * (b)[2];              \
    (c)[2] = (a)[2] * (b)[0] + (a)[5] * (b)[1] + (a)[8] * (b)[2];

#define matmat(a, b, c)                                                        \
    (c)[0] = (a)[0] * (b)[0] + (a)[3] * (b)[1] + (a)[6] * (b)[2];              \
    (c)[1] = (a)[1] * (b)[0] + (a)[4] * (b)[1] + (a)[7] * (b)[2];              \
    (c)[2] = (a)[2] * (b)[0] + (a)[5] * (b)[1] + (a)[8] * (b)[2];              \
    (c)[3] = (a)[0] * (b)[3] + (a)[3] * (b)[4] + (a)[6] * (b)[5];              \
    (c)[4] = (a)[1] * (b)[3] + (a)[4] * (b)[4] + (a)[7] * (b)[5];              \
    (c)[5] = (a)[2] * (b)[3] + (a)[5] * (b)[4] + (a)[8] * (b)[5];              \
    (c)[6] = (a)[0] * (b)[6] + (a)[3] * (b)[7] + (a)[6] * (b)[8];              \
    (c)[7] = (a)[1] * (b)[6] + (a)[4] * (b)[7] + (a)[7] * (b)[8];              \
    (c)[8] = (a)[2] * (b)[6] + (a)[5] * (b)[7] + (a)[8] * (b)[8];

#endif /* IMAGED11_CMATH_H */
